import re
import lib_california_euler as lib_cali
import numpy as np

# defining the transformation, to be applied at the destination pointcloud
alpha = 0.0872665
beta = 0.122173
gamma = 0
Tx = 10.00
Ty = 20.00
Tz = 30.00

# applying the EULER formula to find the R from alpha,beta,gamma (Rotation Matrix)
R = lib_cali.euler_matrix(alpha,beta,gamma)

# stacking the Translation Matrix on it
R[0,3] = Tx
R[1,3] = Ty
R[2,3] = Tz

# printing for bugcheck 
print(R)

# parsing the original pointcloud to be transformed to our new deformed one
with open("new_data\pointcloud.xyz") as f:
    lines = f.readlines()
    for line in lines:
        # one line per time, splitted with spaces
        x = float(re.split('\s+', line)[0])
        y = float(re.split('\s+', line)[1])
        z = float(re.split('\s+', line)[2])
        line_array = np.array([(x),(y),(z),(1)])
        
        # dot product in order to transform the point cloud into the new one
        temp_array = np.dot(R,line_array)
        
        # write the transformed pointcloud into the new changed_pointcloud.xyz file
        with open("new_data\changed_pointcloud.xyz", "a") as myfile:
            myfile.write(str(temp_array[0])+' '+str(temp_array[1])+' '+str(temp_array[2])+'\n')